/***********************************************************

	pic24glcd.c

	Version 0.91: 2009/02/12

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys24.h"

#ifdef USE_GLCD

extern const byte FONT[] ;

byte pinGLCDdata[] = {DBUS1,DBUS2,DBUS3,DBUS4,DBUS5,DBUS6,DBUS7,DBUS8} ;
byte ePin = GLCD_E ;
byte rwPin = GLCD_RW ;
byte diPin = GLCD_DI ;
byte cs1Pin = GLCD_CS1 ;
byte cs2Pin = GLCD_CS2 ;

byte connectUSB ;


static void __GLCD_dataWrite(byte bank, byte data) ;
static void __GLCD_cmdWrite(byte bank, byte data) ;
byte GLCD_statusRead(byte bank) ;

static char __scrollTop, __scrollBottom ;


/***********************************************************
	OtBbNt̏
***********************************************************/

void
GLCD_initDefault()
{
	/* VXe̋NシȂ킿GLCD̋N㎞Ԃ̊mF */
	while (millis() < 30)
		;

	pinMode(ePin, OUTPUT);      // sets the digital pin as output
	bitOut(ePin, LOW);
  
	pinMode(rwPin, OUTPUT);
	pinMode(diPin, OUTPUT);
	pinMode(cs1Pin, OUTPUT);
	pinMode(cs2Pin, OUTPUT);
//	bitOut(cs1Pin, HIGH);

	TRISB &= 0xff00 ;	// f[^oXo̓[hɐݒ

	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_DISPLAY_ON) ;

	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_SET_ADDRESS | 0) ;
	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_PAGE_ADDRESS_SET | 0) ;

	GLCD_clear(GLCD_SELECT_ALL) ;
	
	__scrollTop = 0 ;
	__scrollBottom = 7 ;
}


static byte
__GLCD_dataGet(byte bank)
{
//	int i ;
	byte data ;

	bitOut(rwPin, HIGH);
	bitOut(cs1Pin, bank & 0x01);
	bitOut(cs2Pin, bank & 0x02);

	TRISB |= 0xff ;	// f[^oX̓[h
/* 
	for (i = 0; i < 8; i++)
		pinMode(pinGLCDdata[i], INPUT) ;
*/

	/* _~[[h */
	noInterrupts() ;
	bitOut(ePin, HIGH);
	delayMicroseconds(1) ;
	bitOut(ePin, LOW);
	interrupts() ;

	delayMicroseconds(4) ;

	/* قƂ̓ǂݏo */
	noInterrupts() ;
	bitOut(ePin, HIGH);
	delayMicroseconds(1) ;

	data = PORTB & 0xff ;
/*
	for (i = 0, data = 0; i < 8; i++) {
		data <<= 1 ;
		data |= digitalRead(pinGLCDdata[7 - i]) ;
	}
*/

	bitOut(ePin, LOW);
	interrupts() ;

	TRISB &= ~0xff ; // f[^oXo̓[h
/*
	for (i = 0; i < 8; i++)
		pinMode(pinGLCDdata[i], OUTPUT) ;
*/
	return data ;
}


static void
__GLCD_dataSet(byte bank, byte data)
{
//	int i ;
	
	bitOut(rwPin, LOW);
	bitOut(cs1Pin, bank & 0x01);
	bitOut(cs2Pin, bank & 0x02);
	delayMicroseconds(1) ;
  
	noInterrupts() ;
	bitOut(ePin, HIGH);

	LATB = (LATB & 0xff00) | data ;
/*
	for (i = 0; i < 8; i++, data >>= 1)
		bitOut(pinGLCDdata[i], data & 0x01) ;
*/
	delayMicroseconds(1) ;
  
	bitOut(ePin, LOW);
	interrupts() ;

}

byte
GLCD_dataRead(byte bank)
{
	bitOut(diPin, HIGH);

	return __GLCD_dataGet(bank) ;
}

void
__GLCD_dataWrite(byte bank, byte data)
{
	bitOut(diPin, HIGH);

	__GLCD_dataSet(bank, data) ;
}

byte
GLCD_statusRead(byte bank)
{
	bitOut(diPin, LOW);

	return __GLCD_dataGet(bank) ;
}

void
__GLCD_cmdWrite(byte bank, byte data)
{
	bitOut(diPin, LOW);

	__GLCD_dataSet(bank, data) ;
}


/***********************************************************
	ʏ
***********************************************************/

void
GLCD_clear(byte cs)
{
	int p, i ;

	__GLCD_cmdWrite(cs, GLCD_DISPLAY_START_LINE | 0) ;

	for (p = 0; p < 8; p++) {
		__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | p) ;

		for (i = 0; i < 64; i++)
			__GLCD_dataWrite(cs, 0b00000000) ;
	}

	__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | 0) ;
	__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | 0) ;
}


/***********************************************************
	_̕`
***********************************************************/

void
GLCD_pset(int x, int y, int pixel)
{
	char p, col, cs ;
	byte d ;

	if ((x > GLCD_X_MAX) || (x < 0))
		return ;

	if ((y > GLCD_Y_MAX) || (y < 0))
		return ;

	if (x < 64) {
		cs = 1 ;
		col = x ;
	} else {
		cs = 2 ;
		col = x - 64 ;
	}

	d = BIT(7 - (y % 8)) ;
	p = 7 - (y / 8) ;

	__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | p) ;
	__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
	if (pixel)
		d |= GLCD_dataRead(cs) ;
	else
		d = ~d & GLCD_dataRead(cs) ;

	__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
	__GLCD_dataWrite(cs, d) ;
}


void
__GLCD_pset(int x, int y, int pixel)
{
	char p, col, cs ;
	byte d ;

	if (x < 64) {
		cs = GLCD_SELECT_LEFT ;
		col = x ;
	} else {
		cs = GLCD_SELECT_RIGHT ;
		col = x - 64 ;
	}

/*
	d = BIT(7 - (y % 8)) ;
	p = 7 - (y / 8) ;
*/
	d = BIT(7 - (y & 0b111)) ;
	p = 7 - (y >> 3) ;

	__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | p) ;
	__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
	if (pixel)
		d |= GLCD_dataRead(cs) ;
	else
		d = ~d & GLCD_dataRead(cs) ;

	__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
	__GLCD_dataWrite(cs, d) ;
}


/***********************************************************
	̕`
***********************************************************/

void
GLCD_drawLine(int x, int y, int x1, int y1, int pixel)
{
	int dx, dy, adx, ady, dd, da ;
	int tmp ;
	char pg, col, cs ;
	byte d0, d ;

	if ((x > GLCD_X_MAX) || (x < 0))
		return ;

	if ((y > GLCD_Y_MAX) || (y < 0))
		return ;

	if ((x1 > GLCD_X_MAX) || (x1 < 0))
		return ;

	if ((y1 > GLCD_Y_MAX) || (y1 < 0))
		return ;

	dx = x - x1 ;
	dy = y - y1 ;

	if (dx == 0) {
		/* c̒ */
		if (y > y1) {
			tmp = y1 ;
			y1 = y ;
			y = tmp ;
		}

		if (x < 64) {
			cs = GLCD_SELECT_LEFT ;
			col = x ;
		} else {
			cs = GLCD_SELECT_RIGHT ;
			col = x - 64 ;
		}

		for ( ; y <= y1; y++) {
			d = BIT(7 - (y & 0b111)) ;
			pg = 7 - (y >> 3) ;

			__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | pg) ;
			__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
			d |= GLCD_dataRead(cs) ;

			__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
			__GLCD_dataWrite(cs, d) ;
		}	
	} else if (dy == 0) {
		/* ̒ */
		if (x > x1) {
			tmp = x1 ;
			x1 = x ;
			x = tmp ;
		}

		d0 = BIT(7 - (y & 0b111)) ;
		pg = 7 - (y >> 3) ;
		__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_PAGE_ADDRESS_SET | pg) ;

		for ( ; x <= x1; x++) {
			if (x < 64) {
				cs = GLCD_SELECT_LEFT ;
				col = x ;
			} else {
				cs = GLCD_SELECT_RIGHT ;
				col = x - 64 ;
			}

			__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
			d = d0 | GLCD_dataRead(cs) ;

			__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;
			__GLCD_dataWrite(cs, d) ;
		}	
	} else {
		/* ΂߂̒ */
		adx = dx > 0 ? dx : -dx ;
		ady = dy > 0 ? dy : -dy ;
		if (adx > ady) {
			dd = dy << 8 ;
			dd /= dx ;

			if (x > x1) {
				tmp = x1 ;
				x1 = x ;
				x = tmp ;
				dd = -dd ;
			}

			da = y << 8 ;
			for ( ; x <= x1; x++) {
				__GLCD_pset(x, da >> 8, pixel) ;
				da += dd ;
			}	
		} else {
			dd = dx << 8 ;
			dd /= dy ;

			if (y > y1) {
				tmp = y1 ;
				y1 = y ;
				y = tmp ;
				dd = -dd ;
			}

			da = x << 8 ;
			for ( ; y <= y1; y++) {
				__GLCD_pset(da >> 8, y, pixel) ;
				da += dd ;
			}	
		}	
	}	
}


/***********************************************************
	`̕`
***********************************************************/

void
GLCD_drawRectangle(int x, int y, int x1, int y1, int pixel)
{
	if ((x > GLCD_X_MAX) || (x < 0))
		return ;

	if ((y > GLCD_Y_MAX) || (y < 0))
		return ;

	if ((x1 > GLCD_X_MAX) || (x1 < 0))
		return ;

	if ((y1 > GLCD_Y_MAX) || (y1 < 0))
		return ;
		
	GLCD_drawLine(x, y, x, y1, pixel) ;
	GLCD_drawLine(x1, y, x1, y1, pixel) ;
	GLCD_drawLine(x, y, x1, y, pixel) ;
	GLCD_drawLine(x, y1, x1, y1, pixel) ;
}	


/***********************************************************
	J[\̈ʒu̐ݒ
***********************************************************/

static char _cLine, _cRow ;


void
GLCD_cusorPos(char line, char row)
{
	_cLine = line ;
	_cRow = row ;
}


/***********************************************************
	\̃XN[
***********************************************************/


void
GLCD_setScroll(char top, char bottom)
{
	if (top >= bottom)
		return ;

	if ((top < 0) || (bottom < 0))
		return ;

	if ((top > 7) || (bottom > 7))
		return ;

	__scrollTop = top ;
	__scrollBottom = bottom ;
}

	
void
GLCD_scroll(char top, char bottom)
{
	int i ;
	char p, cs ;
	byte buff[64] ;

	__GLCD_cmdWrite(3, GLCD_DISPLAY_START_LINE | 0) ;

	for (cs = 1; cs < 3; cs++) {
		for (p = top; p < bottom; p++) {
			/* ̍s̃f[^ǂݏo */
			__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | (p + 1)) ;
	
			for (i = 0; i < 64; i++) {
				__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | i) ;
				buff[i] = GLCD_dataRead(cs) ;
			}	

			/* ̍sɏ */
			__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | p) ;
			__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | 0) ;

			for (i = 0; i < 64; i++)
				__GLCD_dataWrite(cs, buff[i]) ;
		}
	}

	/* ŉs̃NA */
	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_PAGE_ADDRESS_SET | bottom) ;
	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_SET_ADDRESS | 0) ;

	for (i = 0; i < 64; i++)
		__GLCD_dataWrite(GLCD_SELECT_ALL, 0b00000000) ;	

	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_SET_ADDRESS | 0) ;
	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_PAGE_ADDRESS_SET | 0) ;
}


/***********************************************************
	̏o
***********************************************************/

void
GLCD_putc(int c)
{
	char col, cs, i ;
	unsigned char d ;

	if (c == '\r') {	// A
		_cRow = 0 ;
		return ;
	} else if (c == '\n') {	// s
		if (++_cLine > __scrollBottom) {
			_cLine = __scrollBottom ;
			GLCD_scroll(__scrollTop, __scrollBottom) ;
		}	
		return ;
	} else if (c < 32)
		return ;
//		c = '@' ;
			
	if ((col = _cRow++ * 6) < 64) {
		cs = 1 ;
	} else {
		cs = 2 ;
		col -= 64 ;
	}

	__GLCD_cmdWrite(GLCD_SELECT_ALL, GLCD_PAGE_ADDRESS_SET | _cLine) ;
	__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | col) ;

	c -= 32 ;
		
	for (i = 0; i < 5; i++, col++) {
		if (col == 64) {
			cs = 2 ;
//			__GLCD_cmdWrite(cs, GLCD_PAGE_ADDRESS_SET | _cLine) ;
			__GLCD_cmdWrite(cs, GLCD_SET_ADDRESS | 0) ;
		}
		d = FONT[c*5 + i] ;
		__GLCD_dataWrite(cs, d) ;
	}

	__GLCD_dataWrite(cs, 0b00000000) ; // ƕƂ̊Ԃ̋
	
	if (_cRow >= 21) {
		_cRow = 0 ;
		if (++_cLine > __scrollBottom) {
			_cLine = __scrollBottom ;
			GLCD_scroll(__scrollTop, __scrollBottom) ;
		}	
	}
}


/***********************************************************
	̏o
***********************************************************/

void
GLCD_puts(char *s)
{
	while (*s)
		GLCD_putc(*s++) ;
}


#endif
