/***********************************************************

	pic24seg7.c

	Version 0.91: 2009/02/12

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys24.h"

#ifdef USE_SEG7

#if defined(PIC_DEV_2550URL)
byte dataPin, clockPin ;
byte segDigit[NDIGIT] ;
#else
static byte dataPin, clockPin ;
static byte segDigit[NDIGIT] ;
#endif


/* 7ZOgLED̃_Ci~bN_̑Ώی */
static unsigned char gDL = 0 ;
/* 7ZOgLED̕\f[^i[̈ */
static byte g7SEG[NDIGIT] ;

/* 7ZOgLED̕\p^[ */
static const byte gPTN[] = {
	0b00111111, /* 0 */
	0b00000110,
	0b01011011,
	0b01001111,
	0b01100110,
	0b01101101,
	0b01111101,
	0b00000111,
	0b01111111,
	0b01100111, /* 9 */
	0b00000000, /* A */
	0b00000000, /* b */
	0b00000000, /* c */
	0b00000000, /* d */
	0b00000000, /* E */
	0b00000000, /* F */
	0b00000000, /*   */
	0b01000000, /* - */
	0b01110110, /* H */
	0b00111000, /* L */
	0b01100011, /* ~ */
	0b01011100, /* _ */
} ;


/***********************************************************
	VZOgLED̏
***********************************************************/

void
SEG7_init(byte dat, byte clk, byte seg1, byte seg2, byte seg3, byte seg4)
{
	int i ;
	
	dataPin = dat ;
	clockPin = clk ;
	segDigit[0] = seg1 ;
	segDigit[1] = seg2 ;
	segDigit[2] = seg3 ;
	segDigit[3] = seg4 ;

	pinMode(clockPin, OUTPUT) ;
	pinMode(dataPin, OUTPUT) ;

	shiftOut(dataPin, clockPin, LSBFIRST, 0xff) ;

	for (i = 0; i < NDIGIT; i++) {
	   pinMode(segDigit[i], OUTPUT) ;
	   bitOut(segDigit[i], HIGH) ;
    }
}


/***********************************************************
	VZOgLEDւ̏o
***********************************************************/

/* 7ZOgLEDւ1o */
void
SEG7_setDigit(char i, char n)
{
	if (n >= sizeof(gPTN)/sizeof(byte)) {
		/* Ȓl̏ꍇɂ́A */
		g7SEG[(i & 3)] = 0b00000000 ;
	} else {
		/* lɑΉ_p^[̐ݒ */
		g7SEG[(i & 3)] = gPTN[n] ;

		/* 傫ꍇɂ́Ahbgǉ\ */
		if (i >= NDIGIT)
			g7SEG[(i & 3)] |= 0b10000000 ;
	}
}


/* lS̃f[^Ƃĕ\ */
void
SEG7_write(int n, byte type)
{
	byte sign = FALSE ;
	byte head = SEG7_BLANK ;
	
	if (n < 0) {
		sign = TRUE ;
		head = SEG7_MINUS ;
		n = -n ;
	}
	
	SEG7_setDigit(3, n % 10) ;

	if (type == SEG7_INT) {
		/* [TvXŕKvłΐ擪Ƀ}CiX\ */
		if (n >= 10) {
			SEG7_setDigit(2, (n / 10) % 10) ;
			if (n >= 100) {
				SEG7_setDigit(1, (n / 100) % 10) ;
				if (n >= 1000) {
					SEG7_setDigit(0, (n / 1000) % 10) ;
				} else {
					SEG7_setDigit(0, head) ;
				}
			} else {
				SEG7_setDigit(1, head) ;
				SEG7_setDigit(0, SEG7_BLANK) ;
			}
		} else {
			SEG7_setDigit(2, head) ;
			SEG7_setDigit(1, SEG7_BLANK) ;
			SEG7_setDigit(0, SEG7_BLANK) ;
		}	
	} else {
		SEG7_setDigit(2, (n / 10) % 10) ;
		SEG7_setDigit(1, (n / 100) % 10) ;
		SEG7_setDigit(0, (n / 1000) % 10 );
	}
}


/***********************************************************
	_Ci~bN\F荞݃T[rX[`̌Ăяo
***********************************************************/

#ifdef	OPTIMIZE

void
isr_SEG7_update()
{
	int i ;

	/* \錅̊mF */
    if (gDL >= NDIGIT)
		gDL = 0 ;

	/* RׂĔANeBu */
	OPT_SEG1 = 1 ;
	OPT_SEG2 = 1 ;
	OPT_SEG3 = 1 ;
	OPT_SEG4 = 1 ;

#if defined(PIC_DEV_2550URL)
	isr_optShiftOut(MSBFIRST, 0xff) ;

	isr_SW_update() ;
#endif

	/* 1̕\f[^(ANeBuEj̏o */
	isr_optShiftOut(MSBFIRST, ~g7SEG[gDL]) ;

	/* ỸRANeBu */
	switch (gDL++) {
		case 0:
			OPT_SEG1 = 0 ;
			break ;
		case 1:
			OPT_SEG2 = 0 ;
			break ;
		case 2:
			OPT_SEG3 = 0 ;
			break ;
		case 3:
			OPT_SEG4 = 0 ;
			break ;
	}
}

#else

void
isr_SEG7_update()
{
	int i ;
	
	/* \錅̊mF */
    if (gDL >= NDIGIT)
		gDL = 0 ;

	/* RׂĔANeBu */
    for (i = 0; i < NDIGIT; i++)
		isr_bitOut(segDigit[i], HIGH) ;

#if defined(PIC_DEV_2550URL)
	shiftOut(dataPin, clockPin, MSBFIRST, 0xff) ;

	isr_SW_update() ;
#endif

	/* 1̕\f[^(ANeBuEj̏o */
	shiftOut(dataPin, clockPin, MSBFIRST, ~g7SEG[gDL]) ;

	/* ỸRANeBu */
	isr_bitOut(segDigit[gDL++], LOW) ;
}

#endif

#endif
